unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Menus, ExtCtrls, StdCtrls,
  StrUtils, LazUTF8;

type

  { TForm1 }

  TForm1 = class(TForm)
    cbxSummit: TComboBox;
    lblSummit: TLabel;

    procedure cbxSummitChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);

    //
    procedure LoadSummits;  // Load Summits from csv
  private
    SummitList: TStringList;
    FComboLists: TList;
    FOrigin: TStringList;
    procedure FilterComboBox(Combo: TComboBox; DefaultItems: TStrings);
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FComboLists := TList.Create;
  FOrigin := TStringList.Create;
  //
  LoadSummits;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  // free
  SummitList.Free;
  FComboLists.Free;
  FOrigin.Free;
end;

procedure TForm1.FilterComboBox(Combo: TComboBox; DefaultItems: TStrings);

  function Origin: TStrings;
  begin
    if Combo.Tag = 0 then
    begin
      Combo.Sorted := true;
      FOrigin.Assign(Combo.Items);
      FComboLists.Add(FOrigin);
      Combo.Tag := Integer(FOrigin);
      Result := Combo.Items;
    end
    else
      Result := TStrings(Combo.Tag);
  end;

var
  Filter: TStrings;
  i: integer;
begin

  if Combo.Text <> EmptyStr then
  begin
    Filter := TStringList.Create;
    try
      for i:=0 to Origin.Count - 1 do
        if AnsiContainsText(Origin[i], Combo.Text) then
        begin
          Filter.Add(Origin[i]);
          Application.ProcessMessages;
        end;

      Application.ProcessMessages;

      Combo.Items.Assign(Filter);
      Combo.DroppedDown := true;
      Combo.SelStart := UTF8Length(Combo.Text);
    finally
      Filter.Free;
    end;
  end else
  begin
    Combo.Items.Assign(DefaultItems);
  end;

end;


procedure TForm1.cbxSummitChange(Sender: TObject);
begin
  if Sender is TComboBox then
    FilterComboBox(TComboBox(Sender), SummitList);
end;


procedure TForm1.LoadSummits;
begin
  SummitList := TStringList.Create;
  SummitList.LoadFromFile('summits.csv');
  SummitList.Sorted := true;
  cbxSummit.AutoComplete := false;
  cbxSummit.Items.Text := SummitList.Text;
end;


end.

